# Copyright (c) 2000 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
__revision__ = '$Id: AddressBook.py,v 1.2 2001/09/21 16:20:00 syt Exp $'

import urllib, time, string, os, sys
from stat import *
from xml.dom.ext import ReleaseNode
from narval.lib import *

DATAFILE = os.path.join(config.get_home(),'data/addressbook.xml')

# Listes de enfants des noeuds name, address...
nameList = ['title','namepref','firstname','surname']
addressList = ['street','zip','town','country','state']
contactList = ['phone','fax','email','web']
orgList = ['job','dpt','subdpt','org']

# those two forms are 2 version for the entry form,
# the first when you want to enter
# a person, the other when you want to enter a company
person_form = '''<h3>You are entering a person</h3>\n
<input type="hidden" name="type" value="Person">\n
<h2>Name</h2>\n
<font color="#008c95"><b>Title</b> </font>\n
<input type="text" size="5"  name="title">\n
<font color="#008c95"><b>Name prefixe</b> </font>\n
<input type="text" size="10"  name="namepref"><br>\n
<font color="#008c95"><b>Surname</b> </font>\n
<input type="text" size="20"  name="surname"><br>\n
<font color="#008c95"><b>Firstname</b></font>\n
<input type="text" size="20" name="firstname"><br>\n
<font color="#008c95"><b>Birthday</b></font>\n
<input type="text" size="10" name="birthday"><br>\n
'''

company_form = '''<h3> you are entering a company</h3>\n
<input type="hidden" name="type" value="Company">\n
<font color="#008c95"><b>Name</b> </font>\n
<input type="text" size="20"  name="name">\n
<font color="#008c95"><b>Activity</b></font>\n
<input type="text" size="20" name="activity"><br>\n
'''

common_form = '''<h2>Address</h2>
<font color="#008c95"><b>No and Street</b></font>\n
<input type="text" size="50" name="street" value=""><br>\n
<font color="#008c95"><b>Zip</b></font>\n
<input type="text" size="8" name="zip" value=""><br>\n
<font color="#008c95"><b>Town</b></font>\n
<input type="text" size="15" name="town" value=""><br>\n
<font color="#008c95"><b>State</b></font>\n
<input type="text" size="20" name="state" value=""><br>\n
<font color="#008c95"><b>Country</b></font>\n
<input type="text" size="20" name="country" value=""><br>\n
<h2>Contacts</h2>
<font color="#008c95"><b>Phone number</b></font>\n
<input type="text" size="17"  name="phone" value=""><br>\n
<font color="#008c95"><b>Fax</b></font>\n
<input type="text" size="17" name="fax" value=""><br>\n
<font color="#008c95"><b>E-mail</b></font>\n
<input type="text" size="17" name="email" value=""> <br>\n
<font color="#008c95"><b>Web_site</b></font>\n
<input type="text" size="17" name="web" value=""><br>\n
<input type="submit" name="op" value="ADD">\n
<hr>\n
'''

chose_form = '''<center>
<input type="submit" name="op" value="Person">\n
<input type="submit" name="op" value="Company"></center><hr>
'''

# AddressBook Interface:
#     def add(self,node): pass
#     # return nothing
#     def remove(self,node): pass
#     # return nothing
#     def modify(self,node_after,node_before): pass
#     # return nothing
#     def update(self,list_of_extern_ad_books,cgi_request): pass
#     # returns nothing
#     def get_entries(self,doc): pass
#     # return a list of entires nodes contained in the addressbook
#     def seek_and_fill(self,node):pass
#     # return a node containing the information contained in node
#     # and the other about this person contained in the AddressBook

      
class AddressBook:
   
    def __init__(self) :
	self.tree = None
        self.read_file()
      
    def read_file(self) :
        try:
            self.document = read_domtree_from_file(DATAFILE)
        except IOError :
            file = open(DATAFILE,'w')
            file.write('''<?xml version="1.0" ?>\n
            <!DOCTYPE addressbook SYSTEM "data/AB_dtd">\n
            <addressbook></addressbook>''')
            file.close()
            self.read_file()
        self.tree = self.document.documentElement

        
    def write_file(self) :
       try:
           write_domtree_to_file(self.document,DATAFILE)
       except IOError :
           open(DATAFILE,'w').write('''<?xml version="1.0" ?>\n
           <!DOCTYPE addressbook SYSTEM "data/AB_dtd">\n
           <addressbook></addressbook>''')
           self.read_file()

    def add(self,node):
        entry = self.tree.ownerDocument.importNode(node,DEEP_COPY)
        self.tree.appendChild(entry)
    
    def remove(self,node):
        self.tree.removeChild(node)
        
    
    def modify(self,node_after,node_before):
        node= self.tree.ownerDocument.importNode(node_after, DEEP_COPY)
        self.tree.replaceChild(node,node_before)

    def get_entries(self,doc):
        pass
    
    def seek_and_fill(self,node):
        
        doc = self.tree.ownerDocument
        xpath = ''
        children = select_many(node,'descendant::text()')
        for child in children:
            if xpath: xpath = xpath + 'and '
            else: xpath = xpath + '*['
            xpath = xpath + 'descendant-or-self::'+\
                    child.parentNode.nodeName + '="%s"'%(child.nodeValue)
        xpath = xpath + ']'
        return select_many(self.tree,"%s" %(xpath))
           

    def update(self,external_list):
        """ Synchronise Narval avec les autres carnets d'adresse
        Puis tiens compte de l'url (process input)
        """
        #FIXME: identits pourries
        self.idref = '1'
        if self.tree.hasChildNodes():
            self.idref =str(int(self.tree.lastChild.getAttributeNS('','idAl'))+1)
        last_modif_Alab = os.stat(DATAFILE)[ST_MTIME]
        for external in external_list:
            addr = external.getAttributeNS('','address')
            classe = external.getAttributeNS('','class')
            module = string.join(string.split(classe,'.')[:-1],'.')
            class_name = string.split(classe,'.')[-1]
            exec("from %s import %s" % (module,class_name))
            object = eval("%s('%s')" % (class_name,addr))
            for entry in object.get_entries(self.tree.ownerDocument):
                if entry.getAttributeNS('','statut')== 'new':
                    new = entry
                    new.setAttributeNS('','idAl',self.idref)
                    self.idref = str(int(self.idref) + 1)
                    self.add(new)
                    # mettre une ligne idAl
                    object.modify(new,entry)
                elif entry.getAttributeNS('','statut')== 'old':
                    node = None
                    try:
                        node = select_one(self.tree,'*[@id="%s"]'% \
                                          (entry.getAttributeNS('','idAl')))
                    except SelectException:
                        #normalement, on ne doit jamais passer ici
                        object.remove(entry)
                        continue
                        # Si l'ente a t supprime de Al AB
                    else :
                        # dans ce cas le noeud existe
                        # On remplace l'ancien par le nouveau modifi
                        entry = self.tree.ownerDocument.importNode(entry,DEEP_COPY)
                        self.modify(entry,node)
                else:
                    ReleaseNode(entry)

                    
       

    def input_process(self,request,external_list):
        self.type_form = '<h3>Please enter a type value</h3>'+ chose_form
        self.end_form = ''
       
        doc = request.ownerDocument
        items = select_many(request,'cgi-item')
        # FIXME really dirty
        #addr = os.environ['HOME']+'/.kde/share/apps/kab/addressbook.database'
        object_list = []
        for external in external_list:
            addr = external.getAttributeNS('','address')
            classe = external.getAttributeNS('','class')
            module = string.join(string.split(classe,'.')[:-1],'.')
            class_name = string.split(classe,'.')[-1]
            exec("from %s import %s" % (module,class_name))
            object = eval("%s('%s')" % (class_name,addr))
            object_list.append(object)
        try:
            op = select_one(request,'cgi-item[@key="op"]/text()').data
            if op == 'ADD':
                type = select_one(request,'cgi-item[@key="type"]/text()').data
                # for person entry
                if type=="Person":
                    entry = doc.createElementNS('','person')
                    entry.setAttributeNS('','idAl',self.idref)
                    name = doc.createElementNS('','name')
                    entry.appendChild(name)
                    birthday = doc.createElementNS('','birthday')
                    entry.appendChild(birthday)
                    # for companies    
                elif type == "Company":
                    entry = doc.createElementNS('','company')
                    entry.setAttributeNS('','idAl',self.idref)
                    activity = doc.createElementNS('','activity')
                    entry.appendChild(activity)
                address = doc.createElementNS('','address')
                entry.appendChild(address)
                contact = doc.createElementNS('','contact')
                entry.appendChild(contact)
                # FIXME: peut tre mieux avec une transfo XSL...???
                for item in items:
                    if item.getAttributeNS('','key')== 'op':continue
                    else:
                        node = doc.createElementNS('',item.getAttributeNS('','key'))
                        node.appendChild(item.firstChild)
                        if item.getAttributeNS('','key') in nameList:
                            name.appendChild(node)
                        elif item.getAttributeNS('','key') in addressList:
                            address.appendChild(node)
                        elif item.getAttributeNS('','key') in contactList:
                            contact.appendChild(node)
                        elif item.getAttributeNS('','key') in orgList:
                            org.appendChild(node)
                        else:
                            entry.appendChild(node)
                self.add(entry)
                for obj in object_list:
                    obj.add(entry)
                                

            elif op=='REMOVE':
                for item  in items :
                    if item.getAttributeNS('','key')=='check':
                        ui = item.firstChild.data
                        entry = select_many(self.tree,
                                             'descendant-or-self::*[@idAl="%s"]'%(ui))
                        if entry :
                            self.remove(entry[0])
                            for obj in object_list:
                                obj.remove(entry[0])
                        
                           
            elif op=='Person':
                self.end_form = common_form  + chose_form
                self.type_form = person_form
                
            elif op=='Company':
                self.end_form = common_form  + chose_form
                self.type_form = company_form

           
                #elif op== 'GOTO':
                
                # write changes in addressbook.xml                
            self.write_file()
        except SelectException: pass




    ## Les fonctions qui suivent permettent de dfinir le code html
    ## qui affiche les personnes et les compagnies entre dans le
    ##Carnet d'addresse
        
    def alphabet_order(self):
        """ function which create the page where names are filed in \
        alphabetic order"""

        #FIXME: faire une page ou sont dispo tous les autres renseignements
        # de kab
        temp=u'<h4>You are seeking a name</h4>'
        # in html, returm a line where all the letters are present.
        #There are link whith names beginning whith this letter
        for letter in string.uppercase:
            temp = temp + '<a href="#letter'+\
                   str(letter)+'">'+str(letter)+'</a>|\n'
        temp = temp + '''<a href="addressbook?page=activity">\n
        look for activity?|</a>\n
        <input type="submit" name="op" value="REMOVE">\n'''
        temp = temp + '<br>'
        # it allow to print a letter only when there is an entry beginning
        #whith it.after the letter appears the list of names, address...
        my_list = select_many(self.tree,'person')+\
                  select_many(self.tree,'company')
        Dic = {}
        for entry in my_list:
            try:
                name = string.strip(select_one(entry,
                                               'name/surname/text()').data)
            except SelectException:
                name = string.strip(select_one(entry,'name/text()').data)
            try:
                Dic[string.upper(name[0])].append(entry)
            except KeyError:
                Dic[string.upper(name[0])]=[entry]
        list = Dic.keys()
        list.sort()
        for  letter in list:
            temp = temp +\
                   '<h2><hr><a name="letter'+str(letter)+\
                   '">'+str(letter)+'</a></h2>\n'                        
            for ent in Dic[letter]:
                if ent.nodeName == 'person':
                    name = u''
                    for attr in nameList:
                        if select_many(ent,'name/%s'%(attr)):
                            name = name +u' '+\
                                   string.strip(select_one(ent,
                                                           u'name/%s/text()'\
                                                           % unicode(attr, 'ISO-8859-1')).data)
                   
                elif ent.nodeName == 'company':
                    name = string.strip(select_one(ent,'name/text()').data)
                act = select_many(ent,'activity/text()')
                if act:
                    activity = act[0].data
                else : activity = u''
                birthday = select_many(ent,'birthday/text()')
                if birthday:
                    birth = "birth date:"+ birthday[0].data
                else:
                    birth = u''
                address=u''
                for info in ['street','zip','town','state','country']:
                    try:
                        address = address+select_one(ent,'address/%s/text()' %\
                                                     info).data + ' '
                    except SelectException:
                        continue
                              
                phones = select_many(ent ,'contact/phone/text()')
                phone = u''
                for num in phones:
                    phone = phone + 'tel: '+ num.data + '\n'
                email=u''
                for mail in select_many(ent,'contact/email/text()'):
                    email = email +  'email: '+ mail.data +'\n'
                fax = u''
                hasfax = select_many(ent,'contact/fax/text()')
                if hasfax:
                    fax = 'fax: '+hasfax[0].data
                web = u''
                hasweb = select_many(ent,'contact/web/text()')
                if hasweb:
                    web = 'web: '+ hasweb[0].data
                id = ent.getAttributeNS('','idAl')
                temp =  temp + u'''<ul><li><input type="checkbox"
                name="check" value="%s">%s\n
                ''' % (id,
                       name+'<br>'+activity+birth+'<br>'+\
                       address +'<br>'+ phone+' '+'<br>'+\
                       email+'<br>' + web)
                temp = temp + u'</li></ul>\n'
        return temp

                    
    def activity_order(self):
        """ function which create the page where names are filed in
        alphabetic order for activities. The scheme is the same as
        alphabet_order
        """
        temp =''
        temp = temp +'<h4>you are seeking an activity</h4>' 
        for letter in string.uppercase:
            temp = temp + '<a href="#letter'+\
                   str(letter)+'">'+str(letter)+'</a>|\n'
        temp = temp + '<a href="addressbook?page=name">\nlook for name?|</a>'
        temp = temp + '<br>'
        Dic = {}
        for entry in select_many(self.tree,'company'):
            act = string.strip(select_one(entry,'activity/text()').data)
            try:
                Dic[string.upper(act[0])].append(entry)
            except KeyError:
                Dic[string.upper(act[0])]=[entry]
        list = Dic.keys()
        list.sort()     
        for letter in list:
            temp = temp +\
                   '<h2><hr><a name="letter'+str(letter)+\
                   '">'+str(letter)+'</a></h2>\n'
            for ent in Dic[letter]:
                act = select_one(ent,'activity/text()').data
                id = select_one(ent,'name/text()').data
                try:
                    phone = 'tel: '+\
                            select_one(ent,'contact/phone/text()').data
                except SelectException:
                    phone = ""
                    
                address = ''
                for info in ['street','zip','town','state','country']:
                    try:
                        address = address+select_one(ent,'address/%s/text()' %\
                                                     info).data + ' '
                    except SelectException:
                        continue
                try:
                    web = select_one(ent,'contact/web/text()').data
                except SelectException:
                    web = ''
                try:
                    email = select_one(ent,'email/text()').data
                except SelectException:
                    email = ''
                temp = temp +'<ul>'
                temp = temp +\
                       '''<li><input type="checkbox" name="check" value="%s">%s\n ''' %\
                       (id,
                        act +'<br>'+id+' '+web+'<br>'+address +'<br>'\
                        +phone +'<br>' +email)
                temp = temp + '</li></ul>\n'
        return temp
                    
                
    def good_order(self,request):
        """ allow to chose the good order for printing entry
        this function (should be in process_input...)
        """

        temp = ''
        page = select_many(request,'cgi-item[@key="page"]/text()')
        if page:
            if page[0].data == 'activity':
                temp = temp + self.activity_order()
                
            elif page[0].data == 'name': 
                temp = temp + self.alphabet_order()      
        else:
            temp = temp + self.alphabet_order()    
        return temp
             
   
    def Address_html(self,request):
        """ Page permettant d'enregistrer et de rechercher une identit
        """
        # here is the beginning of the html page that Narval open 
        return '''<form action=addressbook method=get>
        <h2>AddressBook</h2>
        <hr>%s%s%s<input type="submit" name="op" value="REMOVE">
        </form></body></html>''' % (self.type_form, self.end_form,
                                    self.good_order(request))
  

## MODULE AUTOTEST
if __name__ == "__main__" :
    import sys
    sys.stderr.write("AddressBook module autotest\n---------------------\n")
    add = AddressBook()
    add.read_file()
    add.write_file()
    node = '<person><name><surname>PONS</surname></name></person>'
    from xml.dom.ext.reader import Sax2
    from xml.dom.ext import StripXml
    person=StripXml(Sax2.FromXml(node)).documentElement
    ab=AddressBook()
    ab.seek_and_fill(person)
    #kab.remove(person)
    #print kab.get_kab_entry()
