# Copyright (c) 2000 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
__revision__ = '$Id: CgiRequest.py,v 1.1 2001/09/21 16:21:52 syt Exp $'

from narval.lib import *

MOD_XML = '''<?xml version="1.0" encoding="ISO-8859-1"?><module name="CgiRequest">'''

HEAD = '''<html>
  <head>
    <link rel="stylesheet" type="text/css" href="/pda-style.css">
    <title>Narval is your pal</title>
  </head>
<body>
<h1>Narval Web Services</h1>
''' 

def process_agenda_f(args) :
    doc, output, request, url = get_inputs(args)
    Agenda = load_extension_module('pda', 'Agenda').Agenda
    agd = Agenda()
    agd.process_input(request)
    return return_answer(doc, output, url, '%s%s' % (HEAD, agd.response), '200', '')
MOD_XML = MOD_XML +\
          '''<action name="process_agenda" func="process_agenda_f">
          <input use="yes"><match>http-cgi-request</match></input>
          <output><match>http-response</match></output>
          </action>'''


def process_chat_f(args):
    doc = args.ownerDocument
    output = doc.createElementNS('','outputs') 
    phrase = select_one(args,'http-cgi-request/cgi-item[@key="input_text"]/text()').data
    phrase = string.lower(phrase)
    for regex in chat_d.keys():
        if regex.match(phrase):
            val, act = chat_d[regex]
            txt = val
            if act:
                txt = act(doc, output, phrase, txt)
            break
        else:
            try:
                txt =  str(eval(phrase))
            except:
                txt =  'I did not get that (but I soon will...) :-(<p>'
    return return_answer(doc, output, '/chat', '''%s<h2>Chat</h2>%s
    <form action="chat" method="get">
    Tell:<input type="text" name="input_text"></form></body></html>
    ''' % (HEAD, txt), '200', '')
MOD_XML = MOD_XML +\
          '''<action name="process_chat" func="process_chat_f">
          <description lang="fr">Un petit bout de conversation ?</description>
          <description lang="en">Care for a chat ?</description>
          <input use="yes"><match>http-cgi-request</match></input>
          <output><match>http-response</match></output>
          <output optional="yes" list="yes"><match>start-plan</match></output>
          </action>'''
    
    
def process_address_book_f(args):
    doc, output, request, url = get_inputs(args)
    AddressBook = load_extension_module('pda', 'AddressBook').AddressBook
    add = AddressBook()
    add.read_file
    externals_list = select_many(args,'externals/extern_address_book')
    add.update(externals_list)
    add.input_process(request,externals_list)        
    return return_answer(doc, output, url, ('%s%s')%(HEAD, add.Address_html(request)),
                          '200', '')
MOD_XML = MOD_XML + '''
<action name="process_address_book" func="process_address_book_f">
<input use="yes"><match>http-cgi-request</match></input>
<input optional="yes"><match>externals</match></input>
<output><match>http-response</match></output>
</action>
'''

def process_recipes_f(args) :
    doc, output, request, url = get_inputs(args)
    errc = '200'
    try:
        cmd = select_one(request,'cgi-item[@key="cmd"]/text()').data
    except:
        cmd=None
    if not cmd and url == '/recipes':
        from urllib import quote_plus
        txt = '<h2>Recipes</h2>\n<table border=1 cellpadding=2>\n'
	for recipe in select_many(args,'recipe') :
            fname = '%s.%s' % (recipe.getAttributeNS('','group'),
                               recipe.getAttributeNS('','name'))
            nameq = quote_plus(fname)
            txt = '''%s<tr><td><a href="/recipes?cmd=view&recipe=%s">%s</a>
            </td><td><a href="/recipes?cmd=run&recipe=%s">Run!</a>
            </td></tr>\n''' % (txt, nameq, fname, nameq)
	txt = '%s</table></body></html>' % txt
    elif cmd and url == '/recipes':
        if cmd == 'view':
            from xml.sax.saxutils import escape
            name = select_one(request, 'cgi-item[@key="recipe"]/text()').data
            group, name = string.split(name, '.')
            txt = '<h2>Recipe %s</h2><pre>%s</pre></html>' % (name,
                  escape(elements_to_string(select_many(args,'recipe[@name="%s" and @group="%s"]'%(name, group)))))
        elif cmd == 'run' :
            name = select_one(request, 'cgi-item[@key="recipe"]/text()').data
            txt = '<h2>Recipe %s</h2>Plan %s started.</body></html>' % (name, name)
            st = doc.createElementNS('','start-plan')
            st.setAttributeNS('','recipe',name)
            output.appendChild(st)
        else:
            txt = error('Unknown command  %s' % cmd)
    else:
        txt = error('Unknown url %s' % url)
        errc='404'
    return return_answer(doc, output, url, ('%s%s')%(HEAD, txt), errc, '')
MOD_XML = MOD_XML + '''
<action name="process_recipes" func="process_recipes_f">
  <description lang="en">Display the list of recipes currently in memory</description>
  <description lang="fr">Affiche la liste des recettes actuellement en mmoire
  </description>
  <input><match>http-cgi-request</match></input>
  <input list="yes"><match>recipe</match></input>
  <output><match>http-response</match></output>
  <output optional="yes"><match>start-plan</match></output>
</action>
'''

def process_plans_f(args) :
    doc, output, request, url = get_inputs(args)
    errc='200'
    try:
        cmd = select_one(request,'cgi-item[@key="cmd"]/text()').data
    except:
        cmd=None
    if not cmd and url == '/plans':
        from urllib import quote_plus
        txt = '''<h2>Plans</h2>\n<table border=1 cellpadding=2><tr>
        <td><b>name</b></td><td><b>state</b></td><td><b>decay</b></td>
        <td><b>eid</b></td></tr>'''
	for plan in select_many(args,'plan') :
            name = plan.getAttributeNS('','name')
            eid = plan.getAttributeNS('','eid')
            nameq = quote_plus(name)
            txt = '''%s<tr><td><a href="/plans?cmd=view&eid=%s">%s</a>
            </td><td>%s</td><td>%s</td><td>%s</td></tr>
            ''' % (txt, eid, name, plan.getAttributeNS('','state'),
                   plan.getAttributeNS('','decay'), eid)
	txt = '%s</table></body></html>' % txt
    elif cmd and url == '/plans':
        cmd = select_one(request,'cgi-item[@key="cmd"]/text()').data
        if cmd == 'view':
            from xml.sax.saxutils import escape  
            eid = select_one(request, 'cgi-item[@key="eid"]/text()').data
            txt = '<h2>Plan</h2><pre>%s</pre></html>' % (
                escape(elements_to_string(select_many(
                args,'plan[@eid="%s"]'%(name,eid)))))
        else:
            txt = error('Unknown command  %s' % cmd)
    else:
        txt = error('Unknown url %s' % url)
        errc='404'

    return return_answer(doc, output, url, ('%s%s')%(HEAD, txt), errc, '')
MOD_XML = MOD_XML + '''
<action name="process_plans" func="process_plans_f">
  <description lang="en">Display the list of plans currently in memory</description>
  <description lang="fr">Affiche la liste des plans actuellement en mmoire
  </description>
  <input><match>http-cgi-request</match></input>
  <input list="yes"><match>plan</match></input>
  <output><match>http-response</match></output>
</action>
'''


def _process_f(args, m_name, title) :
    doc, output, request, url = get_inputs(args)
    errc='200'
    try:
        cmd = select_one(request,'cgi-item[@key="cmd"]/text()').data
    except:
        cmd=None
    m_url='/'+m_name+'s'
    if not cmd and url == m_url:
        from urllib import quote_plus
        txt = '<h2>%s%s</h2>\n<table border=1 cellpadding=2>'%(title, 's')
	for x in select_many(args,m_name) :
            name = x.getAttributeNS('','name')
            eid = x.getAttributeNS('','eid')
            nameq = quote_plus(name)
            txt = '''%s<tr><td><a href="%s?cmd=view&eid=%s">%s</a>
            </td></tr>
            ''' % (txt, m_url, eid, name)
	txt = '%s</table></body></html>' % txt
    elif cmd and url == m_url:
        cmd = select_one(request,'cgi-item[@key="cmd"]/text()').data
        if cmd == 'view':
            from xml.sax.saxutils import escape  
            eid = select_one(request, 'cgi-item[@key="eid"]/text()').data
            txt = '<h2>%s</h2><pre>%s</pre></html>' % (
                title, escape(elements_to_string(select_many(
                args,'%s[@eid="%s"]' % (m_name, eid)))))
        else:
            txt = error('Unknown command  %s' % cmd)
    else:
        txt = error('Unknown url %s' % url)
        errc='404'

    return return_answer(doc, output, url, ('%s%s')%(HEAD, txt), errc, '')

process_actions_f = lambda args, m='action', t='Action': _process_f(args, m, t)
MOD_XML = MOD_XML + '''
<action name="process_actions" func="process_actions_f">
  <description lang="en">Display the list of actions currently in memory</description>
  <description lang="fr">Affiche la liste des actions actuellement en mmoire
  </description>
  <input><match>http-cgi-request</match></input>
  <input list="yes"><match>action</match></input>
  <output><match>http-response</match></output>
</action>
'''
process_transforms_f = lambda args, m='transform', t='Transform': _process_f(args, m, t)
MOD_XML = MOD_XML + '''
<action name="process_transforms" func="process_transforms_f">
  <description lang="en">Display the list of transforms currently in memory</description>
  <description lang="fr">Affiche la liste des transforms actuellement en mmoire
  </description>
  <input><match>http-cgi-request</match></input>
  <input list="yes"><match>transform</match></input>
  <output><match>http-response</match></output>
</action>
'''
process_errors_f = lambda args, m='error', t='Error': _process_f(args, m, t)
MOD_XML = MOD_XML + '''
<action name="process_errors" func="process_errors_f">
  <description lang="en">Display the list of errors currently in memory</description>
  <description lang="fr">Affiche la liste des errors actuellement en mmoire
  </description>
  <input><match>http-cgi-request</match></input>
  <input list="yes"><match>plan</match></input>
  <output><match>http-response</match></output>
</action>
'''


# DON'T WORK (NO ACCESS TO ROOT ELEMENTS)
# def process_xpath_f(args) :
#     doc, output, request, url = get_inputs(args)
#     errc='200'
#     try:
#         xpath = select_one(args,'http-cgi-request/cgi-item[@key="xpath"]/text()').data
#     except:
#         xpath = None
#     if xpath and url == '/xpath':
#         from xml.sax.saxutils import escape  
#         txt = '<h2>Xpath visualizer</h2>\n'
#         PrettyPrint (args.parentNode)
#         print 'XPATH', xpath
#         print elements_to_string(select_many(
#             args,xpath))
#         try:
#             txt = '''%s<h3>Element(s) matching %s in memory</h3>
#             <pre>%s</pre></html>''' % (
#                 txt, xpath, escape(elements_to_string(select_many(
#                 args,xpath))))
#         except:
#             txt += 'Bad Xpath'
#     elif url == '/xpath':
#         txt = error('No xpath found')
#     else:
#         txt = error('Unknown url %s' % url)
#         errc='404'
#     return return_answer(doc, output, url, ('%s%s')%(HEAD, txt), errc, '')
# MOD_XML = MOD_XML + '''
# <action name="process_xpath" func="process_xpath_f">
#   <description lang="en">Display the list of elements matching xpath currently in memory</description>
#   <description lang="fr">Affiche les lments correspondat  un xpath actuellement en mmoire
#   </description>
#   <input><match>http-cgi-request</match></input>
#   <input list="yes"><match>plan</match></input>
#   <output><match>http-response</match></output>
# </action>
# '''

MOD_XML = MOD_XML + '''</module>'''

## private methods ############################################################
def get_inputs(args):
    doc = args.ownerDocument
    output = doc.createElementNS('','outputs') 
    request = select_one(args,'http-cgi-request') 
    url = select_one(args,'http-cgi-request/url/text()').data
    return doc, output, request, url

def return_answer(doc, output, url, content_txt, err_code, err_msg):
    ''' add to output standard http response '''
    rep = doc.createElementNS('','http-response')
    rep.setAttributeNS('','errcode', err_code)
    headers = doc.createElementNS('','headers')
    headers.appendChild(doc.createTextNode('Content-type: text/html\n'))
    rep.appendChild(headers)
    urlNode = doc.createElementNS('','url')
    urlNode.appendChild(doc.createTextNode(url))
    rep.appendChild(urlNode)
    if err_msg:
        errmsg = doc.createElementNS('','errmsg')
        errmsg.appendChild(doc.createTextNode(err_msg))
        rep.appendChild(errmsg)
    if content_txt:
        content = doc.createElementNS('','content')
        content.appendChild(doc.createTextNode(content_txt))
        rep.appendChild(content)
        headers.appendChild(doc.createTextNode('Content-length: %d' %
                                               len(content_txt)))
    output.appendChild(rep)      
    return output

def error(msg):
    return '<h2>Error</h2>%s</body></html>' % msg
    
## chat methods ###############################################################
def _chat_execute(doc, output, phrase, txt):
    words = string.split(phrase)
    if len(words) > 1:
        for w in words[1:]:
            s = doc.createElementNS(AL_NS,'start-plan')
            s.setAttributeNS(AL_NS,'recipe',w)
            output.appendChild(s)
            txt += "I'm trying to execute recipe %s right now.<p>" % w
    return txt
## chat dictionnary ###########################################################
#
# {regular_expression : ('response', action_function)}
#
#   where action_function takes 4 standard argument:
#      _ owner document
#      _ output node
#      _ matching sentence
#      _ matching response
#   and return the sentence
b_W = '((\s*)|(.*\s+))'
e_W = '(()|(\s+.*))$'
chat_d = {
    re.compile(b_W+'((bonjour)|(salut))'+e_W) : ('Bonjour :-)<p>', None),
    re.compile(b_W+'((your\s*name)|(who\s+.*\s+you))'+e_W) : ("I'am Narval, your pal", None),
    re.compile(b_W+'((hi)|(hello))'+e_W) : ('Hi! How are you today ?:-)<p>', None),
    re.compile('\s*execute(\s*\w+)*$') : ('', _chat_execute),
    }
