# Copyright (c) 2000 LOGILAB S.A. (Paris, FRANCE).
# http://www.logilab.fr/ -- mailto:contact@logilab.fr
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
__revision__ = '$Id: PageServer.py,v 1.1 2001/09/21 16:21:52 syt Exp $'

from narval.lib import *
from os.path import join

MOD_XML='''<?xml version="1.0" encoding="ISO-8859-1"?><module name='PageServer'>'''

def serve_f(args) :
    url=select_one(args,'http-request/url/text()').data
    doc=args.ownerDocument
    ret=doc.createElementNS('','outputs')
    r=doc.createElementNS('','http-response')
    ret.appendChild(r)
    r.setAttributeNS('','errcode','200')
    ru=doc.createElementNS('','url')
    r.appendChild(ru)
    ru.appendChild(doc.createTextNode(url))
    re=doc.createElementNS('','errmsg')
    r.appendChild(re)
    re.appendChild(doc.createTextNode(''))
    rh=doc.createElementNS('','headers')
    r.appendChild(rh)
    rc=doc.createElementNS('','content')
    r.appendChild(rc)
    if  url == '/' :
        url = join(config.get_home(),'data','index.html')
    else:
        url = join(config.get_home(),'data',url[1:])
    try:
        # DANGER: will serve *any* accessible file -XXX-FIXME-        
        f = open(url)
        data = f.read()
        f.close()
        rc.appendChild(doc.createTextNode(data))
        rh.appendChild(doc.createTextNode('Content-type: text/html\n'))
        rh.appendChild(doc.createTextNode('Content-length: %d' % len(data)))
        #PrettyPrint (ret)
        #return ret
    except IOError:
        ERRMSG = '''<html><head>
        <link rel="stylesheet" type="text/css" href="/pda-style.css">
        <title>Narval is your pal</title></head>
        <body><h1>Narval Web Services</h1>
        <h2>Error</h2>Page not found</body></html>'''
        rc.appendChild(doc.createTextNode(ERRMSG))
        rh.appendChild(doc.createTextNode('Content-type: text/html\n'))
        rh.appendChild(doc.createTextNode('Content-length: %d'%len(ERRMSG)))
        r.setAttributeNS('','errcode','404')
        r.setAttributeNS('','errmsg','Page not found')
    return ret

MOD_XML=MOD_XML+'''
<action name='serve' func='serve_f'>
  <input><match>http-request</match></input>
  <!-- this is the path to find the bookmarks -->
  <!-- XXX FIXME -->
<!--  <input optional='yes'><match>path/text()</match></input> -->
  <!-- this way of doing things is not so good -->
  <output><match>http-response</match></output>
</action>
'''

MOD_XML=MOD_XML+'</module>'


if __name__ == "__main__" :
    print MOD_XML
    from xml.dom.ext.reader import Sax2
    from xml.dom.ext import Print,StripXml
    doc=StripXml(Sax2.FromXml(MOD_XML))
    Print(doc)
