<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:transform xmlns:xsl='http://www.w3.org/1999/XSL/Transform' version='1.0'>
  <xsl:output method='xml' indent='yes' version='1.0'/>
  <xsl:strip-space elements='*'/>

<!-- Narval prototype ====================================================== -->

<prototype>
<description lang="fr">Slectionner les VEVENT d'un VcalXml correspondant au jour courant.</description>
<description lang="en">Select VEVENTs in a VcalXml whose date is the current one.</description>
<input use='yes'><match>VCALENDAR</match></input>
<output list='yes'><match>vcal-item</match></output>
</prototype>

<!-- root ================================================================== -->

  <xsl:template match='arguments'>
    <xsl:variable name='today' select='concat(@years,@months,@monthdays)'/>
    <xsl:variable name='tomorrow' select='concat(@years,@months,string(number(@monthdays)+1))'/>
    <xsl:apply-templates select='VCALENDAR/VEVENT[starts-with(DTSTART/text(),$today) or starts-with(DTSTART/text(),$tomorrow)]'/>
  </xsl:template>

  <xsl:template match='VCALENDAR'>
    <xsl:apply-templates select='VEVENT'/>
  </xsl:template>

  <xsl:template match='VEVENT'>
    <vcal-item>
    <xsl:copy-of select='.'/>
    </vcal-item>
  </xsl:template>
</xsl:transform>

