<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:transform xmlns:xsl='http://www.w3.org/1999/XSL/Transform' version='1.0'>
  <xsl:output method='xml' indent='yes' encoding='ISO-8859-1' version='1.0'/>
  <xsl:strip-space elements='*'/>

<!-- Narval prototype ====================================================== -->

<prototype>
<description lang="fr">Slectionner les VEVENT d'un VcalXml correspondant au jour courant, et les TODOs.</description>
<description lang="en">Select VEVENTs in a VcalXml whose date is the current one, and TODOs.</description>
<input use='yes'><match>VCALENDAR</match></input>
<output optional='yes' list='yes'><match>vcal-item</match></output>
</prototype>

<!-- root ================================================================== -->

  <xsl:template match='arguments'>
    <xsl:variable name='time' select='concat(@years,@months,@monthdays)'/>
    <xsl:apply-templates select='VCALENDAR/VEVENT[starts-with(DTSTART/text(),$time)]'/>
    <xsl:apply-templates select='VCALENDAR/VTODO'/>
  </xsl:template>
  <xsl:template match='VEVENT|VTODO'>
    <vcal-item>
    <xsl:copy-of select='.'/>
    </vcal-item>
  </xsl:template>
</xsl:transform>

